SystemOrganization addCategory: #'Magritte-Deprecated'!

MABasicObject subclass: #MADescriptionBuilderOld
	instanceVariableNames: 'cache'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Magritte-Deprecated'!

!MADescriptionBuilderOld class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/4/2012 15:48'!
default
	^ Default ifNil: [ Default := MAPragmaBuilder new ]! !

!MADescriptionBuilderOld class methodsFor: 'accessing' stamp: 'lr 3/27/2006 13:31'!
default: aBuilder
	Default := aBuilder! !

!MADescriptionBuilderOld class methodsFor: 'building' stamp: 'lr 3/27/2006 13:29'!
for: anObject
	^ self default for: anObject! !

!MADescriptionBuilderOld class methodsFor: 'initialization' stamp: 'lr 7/5/2009 10:52'!
unload
	self default finalize.
	self default: nil! !

!MADescriptionBuilderOld methodsFor: 'private' stamp: 'lr 2/14/2007 09:09'!
build: anObject
	self subclassResponsibility! !

!MADescriptionBuilderOld methodsFor: 'initialization' stamp: 'lr 3/27/2006 13:55'!
finalize
	super finalize.
	self flush; unregister! !

!MADescriptionBuilderOld methodsFor: 'actions' stamp: 'lr 3/27/2006 13:41'!
flush
	cache := IdentityDictionary new! !

!MADescriptionBuilderOld methodsFor: 'accessing' stamp: 'lr 9/12/2007 17:26'!
for: anObject
	^ cache at: anObject ifAbsentPut: [ self build: anObject ]! !

!MADescriptionBuilderOld methodsFor: 'initialization' stamp: 'jf 9/16/2009 13:20'!
initialize
	super initialize.
	self flush; register! !

!MADescriptionBuilderOld methodsFor: 'events' stamp: 'jf 9/16/2009 17:26'!
modified
	self flush! !

!MADescriptionBuilderOld methodsFor: 'actions' stamp: 'jf 9/30/2009 00:19'!
register
	GRPlatform current 
		magritteRegister: self
		forMethodChangeNotificationsUsing: #modified! !

!MADescriptionBuilderOld methodsFor: 'actions' stamp: 'jf 9/30/2009 00:19'!
unregister
	GRPlatform current 
		magritteUnregister: self
		forMethodChangeNotificationsUsing: #modified! !

MADescriptionBuilderOld subclass: #MANamedBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Deprecated'!

!MANamedBuilder commentStamp: 'lr 4/10/2007 21:09' prior: 0!
I dynamically build container descriptions from class-side methods using a simple naming convention for the selector names:

# The method ==#defaultContainer== is called to retrieve the container instance.
# All the unary methods starting with the selector ==#description== are called and should return a valid description to be added to the container.
# All the keyword messages with one argument having a prefix of a method selected in step 2 will be called with the original description to further refine its definition.!

!MANamedBuilder methodsFor: 'private' stamp: 'NickAger 8/24/2011 13:36'!
build: anObject
	| selectors container |
	selectors := SortedCollection withAll: (anObject class allSelectors select: [ :each | each isDescriptionSelector ]).
	container := self build: anObject for: self containerSelector in: selectors.
	^ (selectors select: [ :each | each isDescriptionDefinition ])
		inject: (cache at: anObject put: container)
		into: [ :result :each |
			self containerSelector = each ifFalse: [
				| description |
				description := self build: anObject for: each in: selectors.
				description isDescription
					ifTrue: [ result add: description ] ].
			result ]! !

!MANamedBuilder methodsFor: 'private' stamp: 'lr 8/23/2008 11:51'!
build: anObject for: aSelector in: aCollection
	^ (aCollection select: [ :each | each isDescriptionExtension: aSelector ])
		inject: (anObject perform: aSelector)
		into: [ :result :each | 
			result isNil 
				ifFalse: [ anObject perform: each with: result ] ]! !

!MANamedBuilder methodsFor: 'configuration' stamp: 'lr 2/14/2007 09:03'!
containerSelector
	^ #descriptionContainer! !
